<?
// Version 2010050801, (c) 2010 by W.R.Schulz, Köngen
require_once '_swap.php';
require_once '_smBaseBean.php';

class smileysBean
extends smBaseBean
{
  public $m_SmName = null;
  public $m_SmCode = null;
  public $m_Action = '';
  public $m_Idx    = null;

  protected function evalRequest( $request )
  {
    parent::evalRequest( $request );

    if ( isset( $request['sm_name'] ) )  $this->m_SmName = $request['sm_name'];
    if ( isset( $request['sm_code'] ) )  $this->m_SmCode = $request['sm_code'];
    if ( isset( $request['action'] ) )   $this->m_Action = $request['action'];
    if ( isset( $request['idx'] ) )      $this->m_Idx    = $request['idx'];
  }

  protected function chkUniqueCode()
  {
    $ok  = true;
    $idx = 0;

    while ( $ok  &&  isset( $this->m_Smileys[$idx] ) )
    {
      if ( strcmp( $this->m_SmCode, $this->m_Smileys[$idx] ) == 0 )
      {
        $ok = false;
        $this->m_Errors['sm_code'] = sprintf( 'Der Code "%s" ist bereits vergeben.', htmlspecialchars( $this->m_Smileys[$idx] ) );
      }
      $idx += 2;
    }
  }

  protected function chkIdx()
  {
    $rVal = false;

    if ( !isset( $this->m_Idx ) )
    {
      $this->m_Errors['action'] = 'Es wurde kein Element f&uuml;r die Operation ausgew&auml;hlt.';
    }
    else
    {
      if ( !isset( $this->m_Smileys[$this->m_Idx] ) )
      {
        $this->m_Errors['action'] = 'Der ausgew&auml;hlte Eintrag existiert nicht.';
      }
      else
      {
        $rVal = true;
      }
    }

    return $rVal;
  }

  protected function verify()
  {
    parent::verify();

    switch ( $this->m_Action )
    {
      case 'ad':
        if ( empty( $this->m_SmName ) )  $this->m_Errors['sm_name'] = 'Es muss ein Dateiname angegeben werden.';
        if ( empty( $this->m_SmCode ) )
        {
          $this->m_Errors['sm_code'] = 'Es muss ein Code angegeben werden.';
        }
        else
        {
          $this->chkUniqueCode();
        }
        break;
      case 'rm':
        $this->chkIdx();
        break;
      case 'up':
        if ( $this->chkIdx() )
        {
          if ( $this->m_Idx < 2 )
          {
            $this->m_Errors['action'] = 'Dieses Element kann nicht nach oben geschoben werden.';
          }
        }
        break;
      case 'dn':
        if ( $this->chkIdx() )
        {
          if ( $this->m_Idx >= count( $this->m_Smileys ) - 2 )
          {
            $this->m_Errors['action'] = 'Dieses Element kann nicht nach unten geschoben werden.';
          }
        }
        break;
      case 'tp':
        $this->chkIdx();
        break;
      case 'bt':
        $this->chkIdx();
        break;
      default:
        $this->m_Errors['action'] = sprintf( '"%s" ist eine unbekannte Operation.', htmlspecialchars( $this->m_Action ) );
    }
  }

  public function __construct( $request )
  {
    parent::__construct( $request );
  }

  protected function remove()
  {
    $idx = $this->m_Idx;
    $tmp = $this->m_Smileys;
    unset( $tmp[$idx], $tmp[$idx + 1] );
    $this->m_Smileys = array_values( $tmp );
  }

  protected function toTop()
  {
    $tmp = array();

    $tmp[] = $this->m_Smileys[$this->m_Idx];
    $tmp[] = $this->m_Smileys[$this->m_Idx + 1];

    $idx = 0;
    while ( isset( $this->m_Smileys[$idx] ) )
    {
      if ( $idx != $this->m_Idx )
      {
        $tmp[] = $this->m_Smileys[$idx];
        $tmp[] = $this->m_Smileys[$idx + 1];
      }
      $idx += 2;
    }

    $this->m_Smileys = $tmp;
  }

  public function writeConfig()
  {
    $rVal = false;
    
    switch ( $this->m_Action )
    {
      case 'ad':
        $this->m_Smileys[] = $this->m_SmCode;
        $this->m_Smileys[] = $this->m_SmName;
        break;
      case 'rm':
        $this->remove();
        break;
      case 'up':
        swap( $this->m_Smileys[$this->m_Idx],     $this->m_Smileys[$this->m_Idx - 2] );
        swap( $this->m_Smileys[$this->m_Idx + 1], $this->m_Smileys[$this->m_Idx - 1] );
        break;
      case 'dn':
        swap( $this->m_Smileys[$this->m_Idx],     $this->m_Smileys[$this->m_Idx + 2] );
        swap( $this->m_Smileys[$this->m_Idx + 1], $this->m_Smileys[$this->m_Idx + 3] );
        break;
      case 'tp':
        $this->toTop();
        break;
      case 'bt':
        $this->m_Smileys[] = $this->m_Smileys[$this->m_Idx];
        $this->m_Smileys[] = $this->m_Smileys[$this->m_Idx + 1];
        $this->remove();
        break;
      default:
        // NOP
    }

    $rVal = parent::writeConfig();

    return $rVal;
  }
}
?>
