<?
$Version      = 'Version 2017061201, (c) 2010, 2011, 2015, 2017 by W.R.Schulz, Köngen';
$Title        = 'Shoutbox-Administration - Nachrichten verwalten';

require_once '../cfg/adm.conf';
require_once '../cfg/db.conf';
require_once '_chkCont.php';

function getInClause( $delm )
{
  $rVal = '';

  for( $idx = 0;  isset( $delm[$idx] );  $idx++ )
  {
    if ( $idx > 0 )
    {
      $rVal .= ', ';
    }
    $rVal .= $delm[$idx];
  }

  return $rVal;
}

require_once '_session.php';

$Action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : '';

if ( chkContinue() )
{
  require_once '_contentFrame.php';
  $cf = new contentFrame( 'Nachrichten' );

  require_once '_header.php';

  $cf->writeStart();
?>
<h3>Nachrichten verwalten</h3>
<?
  $db = mysqli_connect( $db_host, $db_user, $db_pass, $db_catalog );

  switch ( $Action )
  {
  case 'delmark':
    if ( isset( $_REQUEST['delm'] ) )
    {
      mysqli_query( $db, 'DELETE FROM '.$db_table.' WHERE id IN ( '.getInClause( $_REQUEST['delm'] ).' )' );
    }
    break;
  case 'del14':
    mysqli_query( $db, 'DELETE FROM '.$db_table.' WHERE time < '.(time() - 14*24*60*60) );
    break;
  case 'del30':
    mysqli_query( $db, 'DELETE FROM '.$db_table.' WHERE time < '.(time() - 30*24*60*60) );
    break;
  case 'delall':
    mysqli_query( $db, 'DELETE FROM '.$db_table );
    break;
  default:
    // NOP;
  }

  $ofs = isset( $_REQUEST['ofs'] ) ? (int)( $_REQUEST['ofs'] ) : 0;
  $cnt = 0;
  $entries = mysqli_query( $db, "SELECT COUNT(*) AS cnt FROM $db_table" );
  if ( isset( $entries )  &&  $entry = mysqli_fetch_array( $entries ) )
  {
    $cnt = $entry['cnt'];
  }

  $entries = mysqli_query( $db, "SELECT * FROM $db_table ORDER BY time DESC LIMIT $adm_max_entries OFFSET $ofs" );
?>
<p class="nav">
<?
  $n = 1;
  for ( $idx = 0;  $idx < $cnt;  $idx += $adm_max_entries )
  {
    if ( $idx == $ofs ) print "[$n]\n";
    else                print '<a class="nav" href="'.$_SERVER['PHP_SELF'].'?ofs='.$idx.$cf->getCssParam().'">['.$n.']</a>'."\n";
    $n++;
  }

  if ( $cnt > 0 )
  {
?>
<br>
Eintrag <?= $ofs + 1 ?> bis <?= min( $ofs + $adm_max_entries, $cnt ) ?> von <?= $cnt ?>
<?
  }
?>
</p>
<?
  if ( isset( $entries ) )
  {
?>
<form method="post" action="<?= $_SERVER['PHP_SELF'] ?>">
  <table class="msg">
<?
    $n = 0;
    while( $entry = mysqli_fetch_array( $entries ) )
    {
      $ipDisp   = empty( $entry['ip'] ) ? '&lt;no ip&gt;' : $entry['ip'];
      $titleStr = date( "Y-m-d H:i:s", $entry['time'] ).' ('.$ipDisp.')';
?>
    <tr>
      <td class="msg_c"><input type="checkbox" name="delm[]" value="<?= $entry['id'] ?>"></td>
      <td class="msg<?= ($n % 2) ?>" title="<?= $titleStr ?>">
        <b><?= $entry['nick'] ?>:</b> <?= $entry['msg'] ?>
      </td>
    </tr>
<?
      $n++;
    }
?>
  </table>
  <p class="nav">
  F&uuml;r alle Nachrichten auf dieser Seite: Markierungen <a onClick="return chkBoxes(true)" href="">setzen</a> / <a onClick="return chkBoxes(false)" href="">aufheben</a>
  </p>
  <p class="nav">
  Aktion:
<?
    if ( $cf->isPreview() )
    {
      echo '  <input type="hidden" name="css" value="'.$cf->getCssName().'">'."\n";
      echo '  <select name="_action">'."\n";
    }
    else
    {
      echo '  <select name="action">'."\n";
    }
?>
    <option value="delmark">Markierte Nachrichten l&ouml;schen</option>
    <option value="del14">Nachrichten &auml;lter 14 Tage l&ouml;schen</option>
    <option value="del30">Nachrichten &auml;lter 30 Tage l&ouml;schen</option>
    <option value="delall">Alle Nachrichten l&ouml;schen</option>
  </select>
  <input type="submit" name="go" value="Ausf&uuml;hren!">
  </p>
</form>
<?
  }

  mysqli_close( $db );

  $cf->writeEnd();
?>
</body>
</html>
<?
}
?>
