<?
$Version = 'Version 2017083101, (c) 2010, 2011, 2013, 2015, 2017 by W.R.Schulz, Köngen';
$Title   = 'Shoutbox';

require_once 'cfg/db.conf';
require_once 'cfg/sb.conf';
require_once 'cfg/smiley.conf';

function format_message( $post )
{
  global $max_msg, $smiley_dir, $smileys;

  // Check length and strip possibly harmful input.
  if ( strlen( $post ) > $max_msg )
  {
    $post = substr( $post, 0, $max_msg );
  }
  $post = htmlentities( $post, ENT_QUOTES, 'utf-8' );

  // Smileys:
  $idx = 0;
  while ( isset( $smileys[$idx] ) )
  {
    $post = str_replace( $smileys[$idx], '<img alt="" src="'.$smiley_dir.$smileys[$idx +1].'" border="0">', $post );
    $idx += 2;
  }

  // ######### HRC Codes:
  $post = preg_replace( "/\[b\](.*)\[\/b\]/iUms", "<b>\\1</b>", $post );
  $post = preg_replace( "/\[i\](.*)\[\/i\]/iUms", "<i>\\1</i>", $post );
  $post = preg_replace( "/\[s\](.*)\[\/s\]/iUms", "<strike>\\1</strike>", $post );
  $post = preg_replace( "/\[u\](.*)\[\/u\]/iUms", "<u>\\1</u>", $post );

  // email link
  $post = preg_replace( "/\[email\](.*)\[\/email\]/msiU", "<a class=\"m\" href=\"mailto:\\1\">\\1</a>", $post );

  // [URL]
  $post = preg_replace( "/\[url\]www.(.*)\[\/url\]/iUms", "<a class=\"m\" href=\"http://www.\\1\" target=_blank>http://www.\\1</a>", $post );
  $post = preg_replace( "/\[url\](.*)\[\/url\]/iUms", "<a class=\"m\" href=\"\\1\" target=_blank>\\1</a>", $post );

  // code ausrichtung
  $post = preg_replace( "/\[code\](.*)\[\/code\]/msiU", "<blockquote><pre><smallfont><i>code:</i><hr>\\1<hr></blockquote></pre></smallfont>", $post );

  // quote ausrichtung
  $post = preg_replace( "/\[quote\](.*)\[\/quote\]/msiU", "<blockquote><smallfont><i>quote:</i><hr>\\1<hr></blockquote></smallfont>", $post );

  // Farbiger Text
  $post = preg_replace( "/\[red\](.*)\[\/red\]/iUms", "<span style=\"color:red\">\\1</span>", $post );
  $post = preg_replace( "/\[green\](.*)\[\/green\]/iUms", "<span style=\"color:green\">\\1</span>", $post );
  $post = preg_replace( "/\[blue\](.*)\[\/blue\]/iUms", "<span style=\"color:blue\">\\1</span>", $post );
  $post = preg_replace( "/\[white\](.*)\[\/white\]/iUms", "<span style=\"color:white\">\\1</span>", $post );

  // sub, sup
  $post = preg_replace( "/\[sub\](.*)\[\/sub\]/iUms", "<sub>\\1</sub>", $post );
  $post = preg_replace( "/\[sup\](.*)\[\/sup\]/iUms", "<sup>\\1</sup>", $post );
  // ########## Ende HRC Codes

  $post = nl2br( $post );

  return $post;
}

function format_title( $post )
{
  global $max_nick;

  // Check length and strip possibly harmful input.
  if ( strlen( $post ) > $max_nick )
  {
    $post = substr( $post, 0, $max_nick );
  }
  $post = htmlentities( $post, ENT_QUOTES, 'utf-8' );

  return $post;
}

require_once '_session.php';

// Get DB-connection.
$db = mysqli_connect( $db_host, $db_user, $db_pass, $db_catalog );

// Check for delete-request.
$DelId = isset( $_REQUEST['del'] ) ? $DelId = htmlentities( $_REQUEST['del'], ENT_QUOTES ) : 0;
if ( $DelId > 0 )
{
  if ( isset( $_SESSION['myMsgs'][$DelId] ) && mysqli_query( $db, "DELETE FROM $db_table WHERE id=$DelId" ) )
  {
    unset( $_SESSION['myMsgs'][$DelId] );
  }
  else
  {
    $DelId = 0;
  }
}

// Get ip address, if possible.
$ip     = isset( $_SERVER['REMOTE_ADDR'] )  ? trim( $_SERVER['REMOTE_ADDR'] ) : NULL;
$ipStr  = empty( $ip )  ? 'NULL'  : "'$ip'";

// Get nick-name, if possible. If a nick was found, (re-)place it into session-data.
$nick = '';
if ( isset( $_SESSION['nick'] ) ) $nick = trim( $_SESSION['nick'] );
if ( isset( $_REQUEST['nick'] ) ) $nick = trim( $_REQUEST['nick'] );
if ( strlen( $nick ) > 0 )        $_SESSION['nick'] = $nick;

// Get message, if possible.
$msg  = isset( $_REQUEST['msg']  )  ? trim( $_REQUEST['msg']  ) : '';

// If nick and msg found, save to DB.
if( $nick != ''  &&  $msg != '' )
{
  $nick = format_title( $nick );
  $msg  = format_message( $msg );
  mysqli_query( $db, "INSERT INTO $db_table (time, ip, nick, msg) VALUES('".time()."', $ipStr, '$nick', '$msg')" );

  $lastID = mysqli_insert_id( $db );
  if ( $lastID > 0 )
  {
    $_SESSION['myMsgs'][$lastID] = true;
  }
}

$entries = mysqli_query( $db, "SELECT * FROM $db_table ORDER BY time DESC LIMIT $max_entries" );

require_once '_header.php';
?>
  <script language="JavaScript" type="text/javascript"><!--
  function emoticon(txt)
  {
    txt=' '+txt+' ';
    if (document.post.msg.createTextRange && document.post.msg.caretPos) {
      var caretPos=document.post.msg.caretPos.text=txt;
    } else {
      document.post.msg.value+=txt;
    }
    document.post.msg.focus();
  }
  function popUp(doc,w,h,s)
  {
    var sb=s?'yes':'no';
    var l=40;
    var t=20;
    open(doc,"","dependent=yes,height="+h+",width="+w+",left="+l+",top="+t+",resizable=yes,scrollbars="+sb);
    return false;
  }
  //--></script>
</head>
<body>
<form name="post" method="post" action=".<?= $CssParam1 ?>">
  <div class="f"><table class="f">
    <tr>
      <td class="f_c">Name:</td>
      <td class="f_i"><input class="f_i" type="text" name="nick" size="<?= $max_inick ?>" maxlength="<?= $max_nick ?>" value="<?= $nick ?>" ></td>
    </tr>
    <tr>
      <td class="f_c">Nachricht:</td>
      <td class="f_i"><input class="f_i" type="text" name="msg" size="<?= $max_imsg ?>" maxlength="<?= $max_msg ?>" value=""></td>
    </tr>
    <tr>
      <td class="f_i" colspan="2"><input class="f_b" type="submit" name="save" value="senden">
        <input class="f_b" type="reset" value="reset"></td>
    </tr>
    <tr>
      <td class="f_i" colspan="2">
        <a class="f" onClick="return popUp('help.php<?= $CssParam1 ?>',480,450,true)" href="">Hilfe</a>
        -&nbsp;<a class="f" onClick="return popUp('smileys.php<?= $CssParam1 ?>',220,320,true)" href="">Smileys</a>
        -&nbsp;<a class="f" onClick="return popUp('archive.php<?= $CssParam1 ?>',240,400,true)" href="">Archiv</a>
        -&nbsp;<a class="f" href=".<?= $CssParam1 ?>">Refresh</a>
      </td>
    </tr>
    <tr>
      <td class="f_i" colspan="2">
<?
$idx = 0;
while ( isset( $smileys[$idx] )  &&  $idx < 20 )
{
  print '        <a class="f" href="javascript:emoticon(\''.$smileys[$idx].'\')"><img alt="" src="'.$smiley_dir.$smileys[$idx +1].'" border="0"></a>'."\n";
  $idx += 2;
}
?>
      </td>
    </tr>
  </table></div>
</form>
<?
if ( $DelId > 0 )
{
  echo '<p class="ack">Nachricht gel&ouml;scht</p>'."\n";
}
?>
<? require '_msgs.php' ?>
</body>
</html>
<?
mysqli_close( $db );
?>
